import { reactive as A, defineComponent as wl, getCurrentInstance as Vl, ref as b, computed as z, onMounted as xl, watchEffect as Pl, toRefs as Bl, resolveComponent as m, resolveDirective as He, openBlock as d, createBlock as f, normalizeStyle as Hl, unref as W, withCtx as n, createVNode as r, withDirectives as L, createElementVNode as se, renderSlot as S, withKeys as Se, createElementBlock as M, Fragment as k, renderList as Y, mergeProps as H, createCommentVNode as $, vShow as Sl, createTextVNode as U, toDisplayString as de, createSlots as Ae, resolveDynamicComponent as Al, normalizeProps as Ml, guardReactiveProps as kl } from "vue";
import { ElNotification as Rl, ElMessage as Me, ElMessageBox as _e } from "element-plus";
import { useRoute as Ul } from "vue-router";
const j = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Nl(u = { debug: !1 }) {
  const p = A({
    hooks: {}
  });
  return Object.keys(u).forEach((t) => {
    t !== "debug" && (p.hooks[t] = u[t]);
  }), {
    hookHandler: (t, P) => {
      let E = !1;
      try {
        u.debug && (console.group("DeBug\uFF1A", t), console.table(P.Data), console.groupEnd()), E = p.hooks[t](P);
      } catch {
        E = !0;
      }
      return E;
    }
  };
}
const te = (u, p = "success") => {
  Rl({
    title: u,
    type: p,
    offset: 70,
    duration: 2500
  });
};
function R(u) {
  let p;
  try {
    p = Array.isArray(u) ? [] : {}, u === null && (p = null);
  } catch {
    p = {};
  }
  for (const g in u)
    typeof u[g] == "object" ? p[g] = R(u[g]) : p[g] = u[g];
  return p;
}
function ce(u, p) {
  let g = R(u);
  for (var t in p)
    g.hasOwnProperty(t) && typeof p[t] == "object" ? g[t] = ce(g[t], p[t]) : g[t] = p[t];
  return g;
}
function zl(u, p) {
  let g = {}, t = Object.getOwnPropertyNames(u), P = Object.getOwnPropertyNames(p);
  return t.length === P.length && t.forEach((E) => {
    u[E] !== p[E] && (g[E] = p[E]);
  }), g;
}
const $l = {
  debug: !1,
  IssearchForm: !0,
  labelWidth: 120,
  expand: !0,
  expandColumn: 4,
  menuWidth: 310,
  menuAlign: "left",
  dialogWidth: 800,
  editFooterButton: !0,
  pageSizes: [10, 20, 50, 100],
  Pagination: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  PaginationLayout: "->,total, sizes, prev, pager, next, jumper",
  queryAfterMount: !1,
  openMultipleSelection: !1,
  openIndex: !0,
  destroyOnClosModal: !0,
  apiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
};
let x = A({});
function O(...u) {
  x.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...u);
}
const ke = (u) => {
  x = ce($l, u);
};
ke({});
const Ol = /* @__PURE__ */ U(" \u65B0\u589E "), Kl = /* @__PURE__ */ U(" \u6279\u91CF\u5220\u9664 "), Il = { class: "quick-search-area" }, Tl = { style: { display: "flex", "justify-content": "flex-end" } }, ql = /* @__PURE__ */ U("\u53D6\u6D88"), Wl = /* @__PURE__ */ U("\u91CD\u7F6E"), Ll = /* @__PURE__ */ U("\u63D0\u4EA4"), jl = /* @__PURE__ */ wl({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    AddInitID: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    tableHeight: null,
    queryAfterMount: { type: Boolean, default: () => x.queryAfterMount },
    openMultipleSelection: { type: Boolean, default: () => x.openMultipleSelection },
    openIndex: { type: Boolean, default: () => x.openIndex },
    expand: { type: Boolean, default: () => x.expand },
    expandColumn: { default: () => x.expandColumn },
    PaginationLayout: { default: () => x.PaginationLayout },
    fullscreen: { type: Boolean },
    destroyOnClosModal: { type: Boolean, default: () => x.destroyOnClosModal },
    dialogWidth: { default: () => x.dialogWidth },
    closeOnPressEscape: { type: Boolean },
    editFooterButton: { type: Boolean, default: () => x.editFooterButton },
    permission: { default: () => x.permissions }
  },
  emits: ["update:modelValue", "cell-click", "row-contextmenu"],
  setup(u, { expose: p, emit: g }) {
    const t = u;
    O("\u521D\u59CB\u5316\u540E\u7684\u3010\u7CFB\u7EDF\u53C2\u6570\u3011", x), O("\u3010Props\u53C2\u6570\u3011", t);
    const P = Vl(), E = Ul(), K = b(), ie = b(), Ce = b(), pe = b(), Q = b("add"), I = b(!1), Z = b(!1), N = b(!1), Re = b(t.editFooterButton), v = A({ ...ce(x, t.source.options) }), { hookHandler: T } = Nl(t.hooks);
    let q = z(() => v.CrudRequest);
    const D = b({ filter: {}, editor: {}, column: {} }), Ue = b(), fe = b(), Ee = b(), ve = b(), De = b(), _ = b({}), Ne = b({}), y = b({}), be = b({}), ee = b([]), ze = b([]), w = A({
      current: v.Pagination.current,
      pageSize: v.Pagination.pageSize,
      total: v.Pagination.total
    }), J = b(0), me = b(0), ge = b(0), le = b(0);
    if ((() => {
      const { filter: l, editor: a, column: o, columns: c } = t.source;
      let C = {};
      l.forEach((F) => {
        c[F].searchDefaultValue !== void 0 ? C[F] = c[F].searchDefaultValue : C[F] = void 0, D.value.filter[F] = c[F];
      }), ve.value = R(C), _.value = R(ve.value);
      let X = {};
      a.forEach((F) => {
        c[F].addDefaultValue !== void 0 ? X[F] = c[F].addDefaultValue : X[F] = void 0, D.value.editor[F] = c[F];
      }), De.value = R(X), o.forEach((F) => {
        D.value.column[F] = c[F];
      }), Ue.value = c;
    })(), E.params.data) {
      O("\u8DEF\u7531\u4F20\u53C2\uFF1A", E.params.data);
      let l = E.params.data, a = JSON.parse(l);
      _.value = ce(_.value, a), O("searchModel", _);
    }
    const $e = z(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker"];
      return t.source.filter.forEach((o) => {
        a.includes(D.value.filter[o].type) && (l[o] = D.value.filter[o]);
      }), l;
    }), Oe = z(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-cascader", "el-upload"];
      return t.source.editor.forEach((o) => {
        a.includes(D.value.editor[o].type) && G(D.value.editor[o], "visible") && (l[o] = D.value.editor[o]);
      }), l;
    }), Ke = z(() => ({ ...t.wrapperStyle })), Ie = z(() => (w.current - 1) * w.pageSize + 1), Te = z(() => {
      const l = b(0);
      return t.tableHeight ? l.value = t.tableHeight : v.IssearchForm ? l.value = me.value : l.value = ge.value, l.value;
    }), we = z(() => t.fullscreen ? le.value - 50 : le.value > 250 ? le.value - J.value * 0.3 : 250);
    xl(() => {
      J.value = document.documentElement.clientHeight, me.value = J.value - 50 - 20 - 40 - 56 - ie.value.clientHeight - K.value.clientHeight, ge.value = J.value - 50 - 20 - 40 - 56 - ie.value.clientHeight, le.value = J.value - 54 - 62, t.queryAfterMount && V(), t.watchData && t.watchData.forEach((l) => {
        Pl(() => {
          y.value[l.id] && (O("\u76D1\u542C\u7684id\u6570\u636E", y.value[l.id]), l.data.forEach((a) => {
            a.data[l.id] = y.value[l.id], O("\u76D1\u542C\u7684\u6570\u636E\u8BF7\u6C42", a), el(a);
          }));
        });
      }), O("onMounted", h), O("Hight", { clientHeight: J, OpenSearchFormtableMaxHeight: me, CloseSearchFormtableMaxHeight: ge, EditFormMaxHeight: le });
    });
    const he = (l) => {
      let a = {};
      return t.rowKey && (a[t.rowKey] = l[t.rowKey]), t.rowKeys && t.rowKeys.forEach((o) => {
        a[o] = l[o];
      }), a;
    }, ne = (l) => l.formProps && l.formProps.type ? l.range ? l.formProps.type + "range" : l.formProps.type : "date", G = (l, a) => {
      if (a === "disabled")
        return typeof l.disabled == "function" ? l.disabled(h, Q.value) : !1;
      if (a === "visible")
        return typeof l.visible == "function" ? l.visible(h, Q.value) : !0;
    }, qe = (l, a, o, c) => {
      g("cell-click", { row: l, column: a, cell: o, event: c });
    }, We = (l, a, o, c) => {
      a.label && navigator.clipboard.writeText(o.innerText).then(() => {
        Me.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, Le = (l, a, o) => {
      g("row-contextmenu", { row: l, column: a, event: o }, h);
    }, je = (l) => {
      ee.value = l;
    }, Qe = (l) => {
      let a = { ...l };
      return Object.keys(a).forEach((o) => {
        typeof a[o] == "function" && (a[o] = a[o].bind(this, h));
      }), a;
    }, Je = (l, a) => {
      let o = { ...l };
      return Object.keys(o).forEach((c) => {
        typeof o[c] == "function" && (o[c] = o[c].call(this, h, a));
      }), o;
    }, Ge = (l) => {
      w.pageSize = l, V();
    }, Xe = (l) => {
      w.current = l, w.current != null && V();
    }, Ye = (l, a, o) => {
      if (a.type === "el-select") {
        const c = a.formProps.options.findIndex((C) => C.value == l.row[o]);
        return c === -1 ? l.row[o] : a.formProps.options[c].label;
      } else
        return l.row[o];
    }, Ze = () => {
      ue.value.length && ue.value.forEach((l) => {
        D.value.editor[l].formProps.fileList = [];
      });
    }, ue = z(() => {
      let l = [];
      for (const a in D.value.editor)
        if (Object.prototype.hasOwnProperty.call(D.value.editor, a)) {
          const o = D.value.editor[a];
          o.type === "el-upload" && o.formProps.hasOwnProperty("listType") && o.formProps.listType === "picture-card" && l.push(a);
        }
      return l;
    }), el = (l) => {
      q.value({ url: l.url, name: l.name, data: l.data }).then((a) => {
        D.value.editor[l.key].formProps.options = a.data.map((o) => {
          if (typeof l.label == "string")
            return {
              value: o[l.value],
              label: o[l.label]
            };
          if (typeof l.label == "object")
            return {
              value: o[l.value],
              label: o[l.label[0]] + "--" + o[l.label[1]]
            };
        });
      });
    }, V = () => {
      Z.value = !0;
      const l = A({
        ..._.value
      });
      for (const a in l)
        Object.prototype.hasOwnProperty.call(l, a) && typeof l[a] == "string" && (l[a] = l[a].trim(), l[a] === "" && (l[a] = void 0));
      !T(j.beforeQueryHandler, { CrudState: h, Data: l }) || q.value({
        url: t.url,
        name: v.apiName.query,
        data: {
          pagenum: w.current,
          pagesize: w.pageSize,
          ...l
        }
      }).then((a) => {
        const { data: o, page: c } = a;
        setTimeout(() => {
          ll(o, l), w.total = c.total, Z.value = !1;
        }, 50);
      }).catch(() => {
        Z.value = !1;
      });
    }, ll = (l, a) => {
      Object.keys(a).filter((c) => a[c] != null).length == 0 && (Ee.value = l), Ee.value = R(l), T(j.afterQueryHandler, { CrudState: h, Data: l }) && (fe.value = R(l));
    }, al = () => {
      _.value = R(ve.value), V();
    }, ol = (l) => {
      !l || (l.resetFields(), ue.value.length && ue.value.forEach((a) => {
        const o = a + "UploadRef";
        (P == null ? void 0 : P.refs[o])[0].clearFiles();
      }));
    }, tl = () => {
      y.value = R(De.value);
      const l = A({ ...y.value });
      !T(j.beforeAddHandler, { CrudState: h, Data: l }) || (Q.value = "add", I.value = !0);
    }, nl = (l) => {
      const a = A({
        ...l
      });
      !T(j.beforeEditHandler, { CrudState: h, Data: a }) || (Object.keys(a).forEach((o) => {
        y.value[o] = a[o], be.value[o] = a[o];
      }), Q.value = "edit", I.value = !0);
    }, re = async (l) => {
      !l || await l.validate((a) => {
        if (a) {
          const o = A({
            ...y.value
          });
          if (!T(j.beforeSubmitHandler, { CrudState: h, Data: o }))
            return;
          h.Mode === "add" ? ul(o) : rl(o);
        }
      });
    }, ul = (l) => {
      N.value = !0;
      let a = l;
      l.FormData instanceof FormData && (a = l.FormData), q.value({ url: t.url, name: v.apiName.add, data: a }).then(() => {
        I.value = !1, te("\u65B0\u589E\u6210\u529F"), V(), N.value = !1;
      }).catch(() => {
        N.value = !1;
      });
    }, rl = (l) => {
      N.value = !0;
      let a = l;
      if (l.FormData instanceof FormData)
        a = l.FormData;
      else {
        const o = zl(be.value, a);
        if (JSON.stringify(o) === "{}")
          return N.value = !1, Me({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
        a = {
          ...he(l),
          ...o
        };
      }
      q.value({ url: t.url, name: v.apiName.edit, data: a }).then(() => {
        I.value = !1, te("\u4FEE\u6539\u6210\u529F"), V(), N.value = !1;
      }).catch(() => {
        N.value = !1;
      });
    }, sl = (l) => {
      _e.confirm(`\u786E\u5B9A\u8981 \u201C${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l),
          deleteFlag: l.deleteFlag == 0 ? 1 : 0
        });
        !T(j.beforedisabledHandler, { CrudState: h, Data: a }) || q.value({
          url: t.url,
          name: v.apiName.deleteFlag,
          data: a
        }).then(() => {
          te(`\u6570\u636E${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), V();
        });
      }).catch(() => {
      });
    }, dl = (l) => {
      _e.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l)
        });
        !T(j.beforeDeteleHandler, { CrudState: h, Data: a }) || q.value({
          url: t.url,
          name: v.apiName.delete,
          data: a
        }).then(() => {
          te("\u5220\u9664\u6210\u529F"), V();
        });
      }).catch(() => {
      });
    }, cl = () => {
      _e.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = ee.value.map((a) => a[t.rowKey]);
        q.value({
          url: t.url,
          name: v.apiName.remove,
          data: { [t.rowKey]: l, selection: ee.value }
        }).then(() => {
          te("\u6279\u91CF\u5220\u9664\u6210\u529F"), ee.value = [], Ce.value.clearSelection(), V();
        });
      }).catch(() => {
      });
    }, h = A({
      ElementArrs: D,
      tableData: fe,
      searchModel: _,
      searchFormValue: Ne,
      editModel: y,
      editFormValue: be,
      uploadFiles: ze,
      tableLoading: Z,
      Pagination: w,
      Mode: Q,
      queryRecord: V
    });
    return p({
      ...Bl(h)
    }), (l, a) => {
      const o = m("el-input"), c = m("el-form-item"), C = m("el-col"), X = m("el-input-number"), F = m("el-option"), Ve = m("el-select"), ye = m("el-date-picker"), xe = m("el-row"), Pe = m("el-form"), il = m("el-collapse-transition"), B = m("el-button"), pl = m("el-empty"), ae = m("el-table-column"), fl = m("el-descriptions-item"), vl = m("el-descriptions"), bl = m("el-button-group"), ml = m("el-table"), gl = m("el-pagination"), hl = m("el-cascader"), yl = m("plus"), _l = m("el-icon"), Fl = m("el-upload"), Cl = m("el-scrollbar"), Be = m("el-card"), El = m("el-dialog"), oe = He("permission"), Dl = He("loading");
      return d(), f(Be, {
        style: Hl([{ border: "0" }, W(Ke)])
      }, {
        default: n(() => [
          r(il, null, {
            default: n(() => [
              L(se("div", {
                id: "plain",
                ref_key: "searchFormRef",
                ref: K
              }, [
                S(l.$slots, "search-form", {
                  editModel: _.value,
                  queryRecord: V,
                  CrudState: h
                }, void 0, !0),
                r(Pe, {
                  model: _.value,
                  "label-width": v.labelWidth,
                  onKeyup: Se(V, ["enter", "native"])
                }, {
                  default: n(() => [
                    r(xe, null, {
                      default: n(() => [
                        S(l.$slots, "search-form-top", { CrudState: h }, void 0, !0),
                        (d(!0), M(k, null, Y(W($e), (e, s) => (d(), M(k, null, [
                          e.type === "el-input" ? (d(), f(C, {
                            key: 0,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(o, H({
                                    style: { width: "100%" },
                                    modelValue: _.value[s],
                                    "onUpdate:modelValue": (i) => _.value[s] = i,
                                    clearable: "",
                                    placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-input-number" ? (d(), f(C, {
                            key: 1,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(X, H({
                                    style: { width: "100%" },
                                    modelValue: _.value[s],
                                    "onUpdate:modelValue": (i) => _.value[s] = i,
                                    placeholder: "\u8BF7\u8F93\u5165"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-select" ? (d(), f(C, {
                            key: 2,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(Ve, H({
                                    style: { width: "100%" },
                                    modelValue: _.value[s],
                                    "onUpdate:modelValue": (i) => _.value[s] = i,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9"
                                  }, e.formProps), {
                                    default: n(() => [
                                      (d(!0), M(k, null, Y(e.formProps.options, (i) => (d(), f(F, {
                                        key: i.value,
                                        label: i.label,
                                        value: i.value
                                      }, null, 8, ["label", "value"]))), 128))
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && ne(e).includes("range") ? (d(), f(C, {
                            key: 3,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 12
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(ye, H({
                                    style: { width: "100%" },
                                    modelValue: _.value[s],
                                    "onUpdate:modelValue": (i) => _.value[s] = i,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: ne(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && ne(e) ? (d(), f(C, {
                            key: 4,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              r(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  r(ye, H({
                                    style: { width: "100%" },
                                    modelValue: _.value[s],
                                    "onUpdate:modelValue": (i) => _.value[s] = i,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: ne(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : $("", !0)
                        ], 64))), 256)),
                        S(l.$slots, "search-form-bottom", { CrudState: h }, void 0, !0)
                      ]),
                      _: 3
                    })
                  ]),
                  _: 3
                }, 8, ["model", "label-width", "onKeyup"])
              ], 512), [
                [Sl, v.IssearchForm]
              ])
            ]),
            _: 3
          }),
          se("div", {
            ref_key: "buttonAreaRef",
            ref: ie,
            class: "button_area"
          }, [
            L((d(), f(B, {
              type: "primary",
              icon: "plus",
              onClick: tl
            }, {
              default: n(() => [
                Ol
              ]),
              _: 1
            })), [
              [oe, { permission: u.permission, access: [v.permission.add] }]
            ]),
            u.openMultipleSelection ? L((d(), f(B, {
              key: 0,
              disabled: ee.value.length <= 0,
              type: "danger",
              icon: "delete",
              onClick: cl
            }, {
              default: n(() => [
                Kl
              ]),
              _: 1
            }, 8, ["disabled"])), [
              [oe, { permission: u.permission, access: [v.permission.remove] }]
            ]) : $("", !0),
            S(l.$slots, "button-area", { CrudState: h }, void 0, !0)
          ], 512),
          L((d(), f(ml, {
            ref_key: "tableRef",
            ref: Ce,
            data: fe.value,
            "row-key": u.rowKey,
            height: W(Te),
            onCellClick: qe,
            onCellDblclick: We,
            onRowContextmenu: Le,
            onSelectionChange: je
          }, {
            empty: n(() => [
              r(pl, {
                "image-size": 80,
                description: "\u6682\u65E0\u6570\u636E"
              })
            ]),
            default: n(() => [
              u.openMultipleSelection ? (d(), f(ae, {
                key: 0,
                type: "selection",
                width: 44
              })) : $("", !0),
              u.expand ? (d(), f(ae, {
                key: 1,
                type: "expand",
                width: 55
              }, {
                default: n((e) => [
                  r(vl, {
                    column: u.expandColumn,
                    border: ""
                  }, {
                    default: n(() => [
                      (d(!0), M(k, null, Y(u.source.columns, (s, i) => (d(), M(k, { key: i }, [
                        s.hidden ? $("", !0) : (d(), f(fl, {
                          key: 0,
                          label: s.label
                        }, {
                          default: n(() => [
                            U(de(Ye(e, s, i)), 1)
                          ]),
                          _: 2
                        }, 1032, ["label"]))
                      ], 64))), 128))
                    ]),
                    _: 2
                  }, 1032, ["column"])
                ]),
                _: 1
              })) : $("", !0),
              u.openIndex ? (d(), f(ae, {
                key: 2,
                label: "###",
                width: 55,
                "show-overflow-tooltip": ""
              }, {
                default: n(({ row: e, column: s, $index: i }) => [
                  U(de(W(Ie) + i), 1)
                ]),
                _: 1
              })) : $("", !0),
              (d(!0), M(k, null, Y(D.value.column, (e, s) => (d(), f(ae, H({
                key: s,
                align: e.align || "left"
              }, e.tableProps, {
                label: e.label,
                prop: s,
                "show-overflow-tooltip": ""
              }), Ae({ _: 2 }, [
                e.columnSlot ? {
                  name: "default",
                  fn: n((i) => [
                    (d(), f(Al(e.columnSlot.is), Ml(kl(Je(e.columnSlot, i))), null, 16))
                  ])
                } : void 0
              ]), 1040, ["align", "label", "prop"]))), 128)),
              S(l.$slots, "default", {}, void 0, !0),
              r(ae, {
                align: v.menuAlign || "left",
                width: t.keyName ? v.menuWidth : v.menuWidth - 150
              }, {
                header: n(() => [
                  se("div", Il, [
                    t.keyName ? (d(), f(o, {
                      key: 0,
                      style: { width: "150px" },
                      modelValue: _.value[t.keyName],
                      "onUpdate:modelValue": a[0] || (a[0] = (e) => _.value[t.keyName] = e),
                      placeholder: D.value.filter[t.keyName].label + "\u6A21\u7CCA\u67E5\u627E",
                      clearable: "",
                      onKeyup: Se(V, ["enter", "native"])
                    }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : $("", !0),
                    r(bl, null, {
                      default: n(() => [
                        r(B, {
                          color: "#67c23a",
                          icon: "search",
                          onClick: V
                        }),
                        r(B, {
                          color: "#e6a23c",
                          icon: "refresh",
                          onClick: al
                        }),
                        r(B, {
                          color: "#409eff",
                          icon: "expand",
                          onClick: a[1] || (a[1] = (e) => v.IssearchForm = !v.IssearchForm)
                        })
                      ]),
                      _: 1
                    })
                  ])
                ]),
                default: n((e) => [
                  S(l.$slots, "menu-top", { scope: e }, void 0, !0),
                  L((d(), f(B, {
                    plain: "",
                    type: e.row.deleteFlag ? "danger" : "success",
                    onClick: (s) => sl(e.row)
                  }, {
                    default: n(() => [
                      U(de(e.row.deleteFlag ? "\u7981\u7528" : "\u542F\u7528"), 1)
                    ]),
                    _: 2
                  }, 1032, ["type", "onClick"])), [
                    [oe, { permission: u.permission, access: [v.permission.deleteFlag] }]
                  ]),
                  L(r(B, {
                    plain: "",
                    type: "primary",
                    icon: "edit",
                    onClick: (s) => nl(e.row)
                  }, null, 8, ["onClick"]), [
                    [oe, { permission: u.permission, access: [v.permission.edit] }]
                  ]),
                  L(r(B, {
                    type: "danger",
                    icon: "delete",
                    onClick: (s) => dl(e.row)
                  }, null, 8, ["onClick"]), [
                    [oe, { permission: u.permission, access: [v.permission.delete] }]
                  ]),
                  S(l.$slots, "menu-bottom", { scope: e }, void 0, !0)
                ]),
                _: 3
              }, 8, ["align", "width"])
            ]),
            _: 3
          }, 8, ["data", "row-key", "height"])), [
            [Dl, Z.value]
          ]),
          r(gl, {
            style: { "margin-top": "20px" },
            "hide-on-single-page": "",
            currentPage: w.current,
            "onUpdate:currentPage": a[2] || (a[2] = (e) => w.current = e),
            "page-size": w.pageSize,
            "onUpdate:page-size": a[3] || (a[3] = (e) => w.pageSize = e),
            "page-sizes": v.pageSizes,
            background: "",
            layout: u.PaginationLayout,
            total: w.total,
            onSizeChange: Ge,
            onCurrentChange: Xe
          }, null, 8, ["currentPage", "page-size", "page-sizes", "layout", "total"]),
          r(El, {
            "custom-class": "DialogVisible",
            ref: "dialogRef",
            modelValue: I.value,
            "onUpdate:modelValue": a[7] || (a[7] = (e) => I.value = e),
            title: Q.value === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: v.dialogWidth,
            "destroy-on-close": "",
            fullscreen: u.fullscreen,
            "close-on-click-modal": u.destroyOnClosModal,
            onClosed: Ze
          }, Ae({
            default: n(() => [
              r(Be, {
                class: "edit-form-card",
                shadow: "never"
              }, {
                default: n(() => [
                  r(Cl, {
                    height: W(we),
                    "max-height": W(we)
                  }, {
                    default: n(() => [
                      S(l.$slots, "edit-form", {
                        editModel: y.value,
                        handleSubmit: re,
                        CrudState: h
                      }, void 0, !0),
                      r(Pe, {
                        id: "DialogVisible-edit-form",
                        class: "edit-form",
                        ref_key: "editFormRef",
                        ref: pe,
                        model: y.value,
                        "label-width": v.labelWidth
                      }, {
                        default: n(() => [
                          r(xe, null, {
                            default: n(() => [
                              S(l.$slots, "edit-form-top", {
                                editModel: y.value,
                                handleSubmit: re,
                                CrudState: h
                              }, void 0, !0),
                              (d(!0), M(k, null, Y(W(Oe), (e, s) => (d(), M(k, { key: s }, [
                                e.type === "el-input" ? (d(), f(C, {
                                  key: 0,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(o, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-input-number" ? (d(), f(C, {
                                  key: 1,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(X, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-select" ? (d(), f(C, {
                                  key: 2,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Ve, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), {
                                          default: n(() => [
                                            (d(!0), M(k, null, Y(e.formProps.options, (i) => (d(), f(F, {
                                              key: i.value,
                                              label: i.label,
                                              value: i.value
                                            }, null, 8, ["label", "value"]))), 128))
                                          ]),
                                          _: 2
                                        }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-date-picker" ? (d(), f(C, {
                                  key: 3,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(ye, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-cascader" ? (d(), f(C, {
                                  key: 4,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(hl, H({
                                          style: { width: "100%" },
                                          modelValue: y.value[s],
                                          "onUpdate:modelValue": (i) => y.value[s] = i,
                                          props: e.formProps.props,
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          "show-all-levels": !1,
                                          disabled: G(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-upload" ? (d(), f(C, {
                                  key: 5,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    r(c, {
                                      label: e.label,
                                      prop: s,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        r(Fl, H({
                                          style: { width: "100%" },
                                          ref_for: !0,
                                          ref: s + "UploadRef",
                                          action: ""
                                        }, Qe(e.formProps)), {
                                          default: n(() => [
                                            e.formProps.listType !== "picture-card" ? (d(), f(B, {
                                              key: 0,
                                              type: "primary"
                                            }, {
                                              default: n(() => [
                                                U(de(e.formProps.butName || "\u9009\u62E9\u6587\u4EF6"), 1)
                                              ]),
                                              _: 2
                                            }, 1024)) : (d(), f(_l, { key: 1 }, {
                                              default: n(() => [
                                                r(yl)
                                              ]),
                                              _: 1
                                            }))
                                          ]),
                                          _: 2
                                        }, 1040)
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : $("", !0)
                              ], 64))), 128)),
                              S(l.$slots, "edit-form-bottom", {
                                editModel: y.value,
                                handleSubmit: re,
                                CrudState: h
                              }, void 0, !0)
                            ]),
                            _: 3
                          })
                        ]),
                        _: 3
                      }, 8, ["model", "label-width"])
                    ]),
                    _: 3
                  }, 8, ["height", "max-height"])
                ]),
                _: 3
              })
            ]),
            _: 2
          }, [
            Re.value ? {
              name: "footer",
              fn: n(() => [
                se("div", Tl, [
                  S(l.$slots, "edit-form-footer", { CrudState: h }, void 0, !0),
                  r(B, {
                    onClick: a[4] || (a[4] = (e) => I.value = !1)
                  }, {
                    default: n(() => [
                      ql
                    ]),
                    _: 1
                  }),
                  r(B, {
                    type: "warning",
                    plain: "",
                    onClick: a[5] || (a[5] = (e) => ol(pe.value))
                  }, {
                    default: n(() => [
                      Wl
                    ]),
                    _: 1
                  }),
                  r(B, {
                    type: "primary",
                    loading: N.value,
                    onClick: a[6] || (a[6] = (e) => re(pe.value))
                  }, {
                    default: n(() => [
                      Ll
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "fullscreen", "close-on-click-modal"])
        ]),
        _: 3
      }, 8, ["style"]);
    };
  }
});
const Ql = (u, p) => {
  const g = u.__vccOpts || u;
  for (const [t, P] of p)
    g[t] = P;
  return g;
}, Fe = /* @__PURE__ */ Ql(jl, [["__scopeId", "data-v-f66401b1"]]), Jl = {
  mounted(u, p, g) {
    const t = p.value.permission, P = p.value.access;
    let E = !1;
    for (let K = 0; K < P.length; K++)
      if (t.includes(P[K])) {
        E = !0;
        break;
      } else
        E = !1;
    E || u.parentNode && u.parentNode.removeChild(u);
  }
};
Fe.install = (u) => {
  u.component("CrudEl", Fe), u.directive("permission", Jl);
};
const Zl = (u, p) => {
  p ? (p.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), ke(p), u.use(Fe)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  ce as DataMerger,
  R as DeepClone,
  ke as InitSys,
  Zl as createCrudEl,
  j as hooksName,
  zl as isObjEqual,
  Nl as useHooks
};
